--[[
Production Revamp
Main Script File

Copyright (C) braeven, 2022

Author: braeven
Thanks for Helping: Achimobil, TethysSaturn, DickerSauerlaender, inconspicuously007, AlfredProm
Date: 21.06.2022
Version: 1.2.0.8

Contact/Help/Tutorials:
discord.gg/gHmnFZAypk


Changelog:
1.2.0.8 @ 21.06.2022 - CodeOptimierung
1.2.0.8 @ 20.06.2022 - Vergessenen Print entfernt.
1.2.0.8 @ 20.06.2022 - Bugfix wenn Silo-Erweiterungen benutzt werden.
1.2.0.7 @ 13.06.2022 - SellPointScript forceRegister hinzugefügt um FilllTypes trotz vorhandener Verkaufsstelle anzulegen.
1.2.0.7 @ 13.06.2022 - SellPointScript Skip hinzugefügt, sollte ein FillType bereits Verkaufsstellen haben.
1.2.0.6 @ 12.06.2022 - Bugfix vom Bugfix
1.2.0.5 @ 11.06.2022 - Bugfix bei UnloadTriggern, Ställe sollten jetzt wieder Güten annehmen
1.2.0.4 @ 11.06.2022 - RevampSpawner um Cooldown-Timer beim Spawnen erweitert
1.2.0.2 @ 10.06.2022 - XML-Tag hinzugefügt, damit Produktionen immer automatisch eingeschaltet sind
1.2.0.2 @ 10.06.2022 - Produktionen werden jetzt Alphabeltisch sortierte
1.2.0.2 @ 10.06.2022 - Produktion die Versteckt sind, sind jetzt immer eingeschaltet
1.2.0.2 @ 10.06.2022 - Bugfix: Fehlermeldung in der Log, sollte keine gültige Sellingstation für das Sellpoint-script vorhanden sein
1.2.0.2 @ 09.06.2022 - BugFix: Produktionen mit FillTypeCategory lassen das Baumenü nicht mehr Verbuggen
1.2.0.2 @ 08.06.2022 - Bugfix: FillTypeCategorie geändert zu FillTypeCategory
1.2.0.2 @ 08.06.2022 - Ermöglicht FillTypeCategories und FillTypeNames bei UnloadingStation zu verwenden
1.2.0.1 @ 06.06.2022 - Bugfixes
1.2.0.0 @ 01.06.2022 - Added RevampSpawner-Script
1.2.0.0 @ 01.06.2022 - Integrated 5 Scripts from Achimobil
1.1.4.0 @ 27.05.2022 - Added Palletspawner Cooldown 4s when changing Output-Mode - Prevents Pallets from accidently spawning
1.1.4.0 @ 23.05.2022 - Beginning Integration of aPallet-Silo from Achimobil
1.1.4.0 @ 23.05.2022 - Added Option to make Productions invisible
1.1.4.0 @ 23.05.2022 - Added Option to disable buying of Inputs in Productions
1.1.3.1 @ 17.05.2022 - Code Cleanup
1.1.3.1 @ 17.05.2022 - Bugfix sharedThroughputCapacity wird nun nurnoch im ProduktionsMenü angezeigt
1.1.3.1 @ 16.05.2022 - Bugfix farbige Rezepte im Multiplayer, sollten jetzt angezeigt werden
1.1.3.1 @ 16.05.2022 - Bugfix Einkaufspreise, jetzt wird der richtige Multi benutzt - Danke Achim
1.1.3.0 @ 14.05.2022 - Möglichkeit hinzugefügt Filltypes bei bereits vorhandenen Sellingstations anzumelden.
1.1.2.0 @ 12.05.2022 - Inputs bei Produktionen sind jetzt über 4 Mengen kaufbar.
1.1.2.0 @ 12.05.2022 - Buy Inputs, es wird Überprüft ob überhaupt genug Geld vorhanden ist
1.1.2.0 @ 06.05.2022 - Bugfix bei Reverse-Boostern
1.1.2.0 @ 06.05.2022 - Farbige Darstellung für Rezepte, weiß = vorhanden, rot = fehlt und wird gebraucht, orange = fehlt optional
1.1.2.0 @ 06.05.2022 - Anzeige der Outputs in Abhängigkeit vom Boost-Ergebnis
1.1.1.0 @ 02.05.2022 - Bugfix: Distribution System - Only if the Production-Line in a Production is running, it will receive goods
1.1.1.0 @ 01.05.2022 - Added FillTypeCategories for Inputs
1.1.0.1 @ 30.04.2022 - Fixed Bug with Buying Production Inputs when choosing no
1.1.0.0 @ 30.04.2022 - Added Translations for some Hardcoded Stuff
1.1.0.0 @ 30.04.2022 - Added maximum Storage-Amount for Input/Output
1.1.0.0 @ 30.04.2022 - Added Option to buy Inputs directly in the Production Hud for x2 price
1.1.0.0 @ 28.04.2022 - Added Option to deactivate Productions from receiving Input from the delivery System
1.1.0.0 @ 27.04.2022 - Added WordWrap for Production Inputs after 4(2 for booster) inputs
1.1.0.0 @ 25.04.2022 - Fixed a Revamp Bug with greenhouses(Wechsel zwischen an/aus wenn nicht gekauft)
1.1.0.0 @ 25.04.2022 - Fixed a missing function for Displaying sharedThroughputCapacity
1.1.0.0 @ 24.04.2022 - Added Priority System for Inputs with the Auto Delivery System, Removed deactivated Production-Lines from receiving goods
1.1.0.0 @ 24.04.2022 - fixed a Giants Bug with Direct Delivery Price
1.0.0.0 @ 19.04.2022 - Adjusted to 1.4 changes
1.0.0.0 @ 16.04.2022 - Initial Release


Important:.
No changes are allowed to this script without permission from Braeven.
If you want to make a production with this script, look in the discord channels for tutorials/help or download the FS22_Revamp_Productions Pack for reference
Don't copy the script into a production, load the mod as a dependency!

Es dürfen an diesem Script keine Veränderungen ohne Erlaubnis von Braeven gemacht werden.
Wenn du eine Produktion mit diesem Script bauen möchtest, lese dir die angepinnten Tutorials im Discord durch oder guck dir die FS22_Revamp_Productions an.
Nicht das Script in Produktionen kopieren, ladet den Mod über eine Dependency!

]]



Revamp = {}
Revamp.SellFillTypes = {}
ProductionPoint.OUTPUT_MODE.STORE = 3
ProductionPoint.INPUT_MODE = {}
ProductionPoint.INPUT_MODE.PRIORITY = 10


--Production Revamp: Neue XML-Variablen anmelden die aus der Produktion ausgelesen werden können
function Revamp.registerXMLPaths(schema, basePath)
  schema:register(XMLValueType.STRING, basePath .. ".productions.production(?).inputs.input(?)#mix", "Mixing Group for Input", 0)
  schema:register(XMLValueType.STRING, basePath .. ".productions.production(?).inputs.input(?)#boostfactor", "Boost-Factor for Input", 0)
  schema:register(XMLValueType.STRING, basePath .. ".productions.production(?).outputs.output(?)#boost", "Activate Boost for Output", nil, true)
  schema:register(XMLValueType.STRING, basePath .. ".productions.production(?).inputs.input(?)#fillTypeCategory", "Input fillTypeCategory", nil, true)
  schema:register(XMLValueType.BOOL, basePath .. ".productions.production(?).inputs.input(?)#allowbuying", "Allows Filltype to be bought inside the production GUI", true)
  schema:register(XMLValueType.BOOL, basePath .. ".productions#hideFromMenu", "Hides Production from the Ingame-Menu", false)
  schema:register(XMLValueType.BOOL, basePath .. ".productions#autoStart", "Automatically starts a production", false)
end

ProductionPoint.registerXMLPaths = Utils.prependedFunction(ProductionPoint.registerXMLPaths, Revamp.registerXMLPaths)



--Production Revamp: Neuen Savegame-Variable anlegen, damit der Modus "Einlagern" gespeichert werden kann & die PrioritätsEinstellung gespeichert wird
function Revamp.registerSavegameXMLPaths(schema, basePath)
  schema:register(XMLValueType.STRING, basePath .. ".storageFillType(?)", "fillType currently configured to be stored")
  schema:register(XMLValueType.STRING, basePath .. ".priorityFillType(?)", "fillType currently configured to be stored")
end

ProductionPoint.registerSavegameXMLPaths = Utils.prependedFunction(ProductionPoint.registerSavegameXMLPaths, Revamp.registerSavegameXMLPaths)
print("Production Revamp: XML-Paths registered")



--Production Revamp: Load Funktion komplett überarbeitet, um diverse neue Funktionen zu ermöglichen
function Revamp:load(superFunc, components, xmlFile, key, customEnv, i3dMappings)
  self.node = components[1].node
  local name = xmlFile:getValue(key .. "#name")
  self.name = name and g_i18n:convertText(name, customEnv)
  self.productions = {}
  self.productionsIdToObj = {}
  self.inputFillTypeIds = {}
  self.inputFillTypeIdsArray = {}

  self.outputFillTypeIds = {}
  self.outputFillTypeIdsArray = {}
  self.outputFillTypeIdsDirectSell = {}
  self.outputFillTypeIdsAutoDeliver = {}
  self.outputFillTypeIdsToPallets = {}
  --Production Revamp: Storage-Liste hinzugefügt für "Einlagern" Funktion bei Produktionen
  self.outputFillTypeIdsStorage = {}
  --Production Revamp: Prioritäten-Liste hinzugefügt für Inputs beim Verteilen.
  self.inputFillTypeIdsPriority = {}

  --Production Revamp: Add pendingLiters für RevampSpawner-Script
  self.pendingLiters = 0
  self.sharedThroughputCapacity = xmlFile:getValue(key .. ".productions#sharedThroughputCapacity", true)
  self.hideFromMenu = xmlFile:getValue(key .. ".productions#hideFromMenu", false)
  self.autoStart = xmlFile:getValue(key .. ".productions#autoStart", false)
  local usedProdIds = {}

  xmlFile:iterate(key .. ".productions.production", function (index, productionKey)
    local production = {
      id = xmlFile:getValue(productionKey .. "#id"),
      name = xmlFile:getValue(productionKey .. "#name", nil, customEnv, false),
    }
    local params = xmlFile:getValue(productionKey .. "#params")

    if params ~= nil then
      params = params:split("|")

      for i = 1, #params do
        params[i] = g_i18n:convertText(params[i], customEnv)
      end

      production.name = string.format(production.name, unpack(params))
    end

    if not production.id then
      Logging.xmlError(xmlFile, "missing id for production '%s'", production.name or index)

      return false
    end

    for i = 1, #usedProdIds do
      if usedProdIds[i] == production.id then
        Logging.xmlError(xmlFile, "production id '%s' already in use", production.id)

        return false
      end
    end

    table.insert(usedProdIds, production.id)

    local cyclesPerMonth = xmlFile:getValue(productionKey .. "#cyclesPerMonth")
    local cyclesPerHour = xmlFile:getValue(productionKey .. "#cyclesPerHour")
    local cyclesPerMinute = xmlFile:getValue(productionKey .. "#cyclesPerMinute")
    production.cyclesPerMinute = cyclesPerMonth and cyclesPerMonth / 60 / 24 or cyclesPerHour and cyclesPerHour / 60 or cyclesPerMinute or 1
    production.cyclesPerHour = cyclesPerHour or production.cyclesPerMinute * 60
    production.cyclesPerMonth = cyclesPerMonth or production.cyclesPerHour * 24
    local costsPerActiveMinute = xmlFile:getValue(productionKey .. "#costsPerActiveMinute")
    local costsPerActiveHour = xmlFile:getValue(productionKey .. "#costsPerActiveHour")
    local costsPerActiveMonth = xmlFile:getValue(productionKey .. "#costsPerActiveMonth")
    production.costsPerActiveMinute = costsPerActiveMonth and costsPerActiveMonth / 60 / 24 or costsPerActiveHour and costsPerActiveHour / 60 or costsPerActiveMinute or 1
    production.costsPerActiveHour = costsPerActiveHour or production.costsPerActiveMinute * 60
    production.costsPerActiveMonth = costsPerActiveMonth or production.costsPerActiveHour * 24
    
    --Production Revamp: Produktions-Status auf an setzen für versteckte Produktionen
    if self.hideFromMenu or self.autoStart then
      production.status = ProductionPoint.PROD_STATUS.MISSING_INPUTS
    else
      production.status = ProductionPoint.PROD_STATUS.INACTIVE
    end
    production.inputs = {}

    xmlFile:iterate(productionKey .. ".inputs.input", function (inputIndex, inputKey)
      local input = {}

    --Production Revamp: Input über FillTypeCategory ermöglichen, funktioniert nur mit gleichen Input-Mengen
    local fillTypeCategoriesString = xmlFile:getValue(inputKey .. "#fillTypeCategory")

    if fillTypeCategoriesString == nil then
      local fillTypeString = xmlFile:getValue(inputKey .. "#fillType")
        input.type = g_fillTypeManager:getFillTypeIndexByName(fillTypeString)

        if input.type == nil then
          Logging.xmlError(xmlFile, "Unable to load fillType '%s' for '%s'", fillTypeString, inputKey)
        else
          --Production Revamp: mix und boostfactor aus der XML auslesen und in der Input-Liste hinterlegen
          input.mix = xmlFile:getValue(inputKey .. "#mix", 0)
          if input.mix == "boost" then
            input.mix = 6
          else
            input.mix = tonumber(input.mix)
          end
          --Production Revamp: boostfactor auslesen
          input.boostfactor = xmlFile:getValue(inputKey .. "#boostfactor", 0)

          --Production Revamp: Auslesen ob Kauffunktion nicht möglich sein soll
          input.allowbuying = xmlFile:getValue(inputKey .. "#allowbuying", true)

          --Production Revamp: Farben hinterlegen für Rezept-Anzeige
          input.color = 0

          self.inputFillTypeIds[input.type] = true

          --Production Revamp: Verteil-Priorität hinterlegen für FillTypes, 1 = wichtig, 10 = unwichtig
          self.inputFillTypeIdsPriority[input.type] = 10

          table.addElement(self.inputFillTypeIdsArray, input.type)


          input.amount = xmlFile:getValue(inputKey .. "#amount", 1)
          table.insert(production.inputs, input)
        end
      else
        local fillTypes = g_fillTypeManager:getFillTypesByCategoryNames(fillTypeCategoriesString, "Warning: '" .. tostring(key) .. "' has invalid fillTypeCategory '%s'.")
        local categoriesamount = xmlFile:getValue(inputKey .. "#amount", 1)
        local categoriesmix = xmlFile:getValue(inputKey .. "#mix", 0)
        if categoriesmix == "boost" then
          categoriesmix = 6
        else
          categoriesmix = tonumber(categoriesmix)
        end
        --Production Revamp: boostfactor auslesen für die Categorie
        local categoriesboostfactor = xmlFile:getValue(inputKey .. "#boostfactor", 0)
        --Production Revamp: Auslesen ob Kauffunktion nicht möglich sein soll für die Categorie
        local allowbuying = xmlFile:getValue(inputKey .. "#allowbuying", true)
        for _, fillType in pairs(fillTypes) do
          local input = {}
          input.type = fillType
          input.mix = categoriesmix
          input.boostfactor= categoriesboostfactor
          input.allowbuying = allowbuying
          self.inputFillTypeIds[input.type] = true

          --Production Revamp: Verteil-Priorität hinterlegen für FillTypes, 1 = wichtig, 10 = unwichtig
          self.inputFillTypeIdsPriority[input.type] = 10

          table.addElement(self.inputFillTypeIdsArray, input.type)
      
          input.amount = categoriesamount
          table.insert(production.inputs, input)
        end
      end
    end)

    if #production.inputs == 0 then
      Logging.xmlError(xmlFile, "No inputs for production '%s'", productionKey)

      return
    end

    production.outputs = {}
    production.primaryProductFillType = nil
    local maxOutputAmount = 0

    xmlFile:iterate(productionKey .. ".outputs.output", function (outputIndex, outputKey)
      local output = {}
      local fillTypeString = xmlFile:getValue(outputKey .. "#fillType")
      output.type = g_fillTypeManager:getFillTypeIndexByName(fillTypeString)

      if output.type == nil then
        Logging.xmlError(xmlFile, "Unable to load fillType '%s' for '%s'", fillTypeString, outputKey)
      else
        output.sellDirectly = xmlFile:getValue(outputKey .. "#sellDirectly", false)
        --Production Revamp: boost aus der XML auslesen und in der Output-Liste hinterlegen
        output.boost = xmlFile:getValue(outputKey .. "#boost")
    
        if output.boost == nil then
          output.boost = "true"
        end

        if not output.sellDirectly then
          self.outputFillTypeIds[output.type] = true
          --Production Revamp: Alle Produktionen Standardmäßig auf Einlagern
          self.outputFillTypeIdsStorage[output.type] = true
          table.addElement(self.outputFillTypeIdsArray, output.type)
        else
          self.soldFillTypesToPayOut[output.type] = 0
        end

        output.amount = xmlFile:getValue(outputKey .. "#amount", 1)

        table.insert(production.outputs, output)

        if maxOutputAmount < output.amount then
          production.primaryProductFillType = output.type
          maxOutputAmount = output.amount
        end
      end
    end)

    if #production.outputs == 0 then
      Logging.xmlError(xmlFile, "No outputs for production '%s'", productionKey)
    end

    if self.isClient then
      production.samples = {
        active = g_soundManager:loadSampleFromXML(xmlFile, productionKey .. ".sounds", "active", self.baseDirectory, components, 1, AudioGroup.ENVIRONMENT, i3dMappings, nil)
      }
      production.animationNodes = g_animationManager:loadAnimations(xmlFile, productionKey .. ".animationNodes", components, self, i3dMappings)
      production.effects = g_effectManager:loadEffect(xmlFile, productionKey .. ".effectNodes", components, self, i3dMappings)
    end

    if self.productionsIdToObj[production.id] ~= nil then
      Logging.xmlError(xmlFile, "Error: production id '%s' already used", production.id)

      return false
    end

    self.productionsIdToObj[production.id] = production

    table.insert(self.productions, production)
    
    --Production Revamp: Produktion in die Liste der Aktiven Produktionen eintragen, damit diese immer an sind
    if self.hideFromMenu or self.autoStart then
      table.insert(self.activeProductions, production)
    end
    
    return true
  end)

  if #self.productions == 0 then
    Logging.xmlError(xmlFile, "No valid productions defined")
  end

  if self.owningPlaceable == nil then
    print("Error: ProductionPoint.owningPlaceable was not set before load()")

    return false
  end

  self.interactionTriggerNode = xmlFile:getValue(key .. ".playerTrigger#node", nil, components, i3dMappings)

  if self.interactionTriggerNode ~= nil then
    addTrigger(self.interactionTriggerNode, "interactionTriggerCallback", self)
  end

  if self.isClient then
    self.samples = {
      idle = g_soundManager:loadSampleFromXML(xmlFile, key .. ".sounds", "idle", self.baseDirectory, components, 1, AudioGroup.ENVIRONMENT, i3dMappings, nil),
      active = g_soundManager:loadSampleFromXML(xmlFile, key .. ".sounds", "active", self.baseDirectory, components, 1, AudioGroup.ENVIRONMENT, i3dMappings, nil)
    }
    self.animationNodes = g_animationManager:loadAnimations(xmlFile, key .. ".animationNodes", components, self, i3dMappings)
    self.effects = g_effectManager:loadEffect(xmlFile, key .. ".effectNodes", components, self, i3dMappings)
  end

  self.unloadingStation = SellingStation.new(self.isServer, self.isClient)

  self.unloadingStation:load(components, xmlFile, key .. ".sellingStation", self.customEnvironment, i3dMappings, components[1].node)

  self.unloadingStation.storeSoldGoods = true
  self.unloadingStation.skipSell = self.owningPlaceable:getOwnerFarmId() ~= AccessHandler.EVERYONE

  function self.unloadingStation.getIsFillAllowedFromFarm(_, farmId)
    --Production Revamp: Überschrieben um Missionen und Verkaufen zu ermöglichen
    --return g_currentMission.accessHandler:canFarmAccess(farmId, self.owningPlaceable)
    return true
  end

  self.unloadingStation:register(true)

  local loadingStationKey = key .. ".loadingStation"

  if xmlFile:hasProperty(loadingStationKey) then
    self.loadingStation = LoadingStation.new(self.isServer, self.isClient)

    if not self.loadingStation:load(components, xmlFile, loadingStationKey, self.customEnvironment, i3dMappings, components[1].node) then
      Logging.xmlError(xmlFile, "Unable to load loading station %s", loadingStationKey)

      return false
    end

    function self.loadingStation.hasFarmAccessToStorage(_, farmId)
      return farmId == self.owningPlaceable:getOwnerFarmId()
    end

    self.loadingStation.owningPlaceable = self.owningPlaceable

    self.loadingStation:register(true)
  end

  local palletSpawnerKey = key .. ".palletSpawner"

  if xmlFile:hasProperty(palletSpawnerKey) then
    self.palletSpawner = PalletSpawner.new(self.baseDirectory)

    if not self.palletSpawner:load(components, xmlFile, key .. ".palletSpawner", self.customEnvironment, i3dMappings) then
      Logging.xmlError(xmlFile, "Unable to load pallet spawner %s", palletSpawnerKey)

      return false
    end
  end

  if self.loadingStation == nil and self.palletSpawner == nil then
    Logging.xmlError(xmlFile, "No loading station or pallet spawner for production point")

    return false
  end

  if self.palletSpawner ~= nil then
    for fillTypeId, pallet in pairs(self.palletSpawner:getSupportedFillTypes()) do
      if self.outputFillTypeIds[fillTypeId] then
        self.outputFillTypeIdsToPallets[fillTypeId] = pallet
      end
    end
  end

  self.storage = Storage.new(self.isServer, self.isClient)

  self.storage:load(components, xmlFile, key .. ".storage", i3dMappings)
  self.storage:register(true)

  if self.loadingStation ~= nil then
    if not self.loadingStation:addSourceStorage(self.storage) then
    Logging.xmlWarning(xmlFile, "Unable to add source storage ")
    end
    
    g_currentMission.storageSystem:addLoadingStation(self.loadingStation, self.owningPlaceable)
  end

  self.unloadingStation:addTargetStorage(self.storage)

  for inputFillTypeIndex in pairs(self.inputFillTypeIds) do
    if not self.unloadingStation:getIsFillTypeSupported(inputFillTypeIndex) then
      local fillTypeName = g_fillTypeManager:getFillTypeNameByIndex(inputFillTypeIndex)

      Logging.xmlWarning(xmlFile, "Input filltype '%s' is not supported by unloading station", fillTypeName)
    end
  end

  for outputFillTypeIndex in pairs(self.outputFillTypeIds) do
    if (self.loadingStation == nil or not self.loadingStation:getIsFillTypeSupported(outputFillTypeIndex)) and self.outputFillTypeIdsToPallets[outputFillTypeIndex] == nil then
      local fillTypeName = g_fillTypeManager:getFillTypeNameByIndex(outputFillTypeIndex)

      Logging.xmlWarning(xmlFile, "Output filltype '%s' is not supported by loading station or pallet spawner", fillTypeName)
    end
  end

  self.unloadingStation.owningPlaceable = self.owningPlaceable

  g_currentMission.storageSystem:addUnloadingStation(self.unloadingStation, self.owningPlaceable)
  g_currentMission.economyManager:addSellingStation(self.unloadingStation)

  for i = 1, #self.productions do
    local production = self.productions[i]

    for x = 1, #production.inputs do
      local input = production.inputs[x]

      if not self.storage:getIsFillTypeSupported(input.type) then
        Logging.xmlError(xmlFile, "production point storage does not support fillType '%s' used as in input in production '%s'", g_fillTypeManager:getFillTypeNameByIndex(input.type), production.name)

        return false
      end
    end

    for x = 1, #production.outputs do
      local output = production.outputs[x]

      if not output.sellDirectly and not self.storage:getIsFillTypeSupported(output.type) then
        Logging.xmlError(xmlFile, "production point storage does not support fillType '%s' used as an output in production '%s'", g_fillTypeManager:getFillTypeNameByIndex(output.type), production.name)

        return false
      end
    end
  end

  for supportedFillType, _ in pairs(self.storage:getSupportedFillTypes()) do
    if not self.inputFillTypeIds[supportedFillType] and not self.outputFillTypeIds[supportedFillType] then
      Logging.xmlWarning(xmlFile, "storage fillType '%s' not used as a production input or ouput", g_fillTypeManager:getFillTypeNameByIndex(supportedFillType))
    end
  end

  return true
end

ProductionPoint.load = Utils.overwrittenFunction(ProductionPoint.load, Revamp.load)
print("Production Revamp: ProductionPoint Load overwritten")



--Production Revamp: Überschrieben um neues Produktionsscript einfügen zu können
function Revamp:updateProduction()
  if self.lastUpdatedTime == nil then
    self.lastUpdatedTime = g_time
    return
  end

  local dt = MathUtil.clamp(g_time - self.lastUpdatedTime, 0, 30000)
  local timeAdjust = g_currentMission.environment.timeAdjustment
  local numActiveProductions = #self.activeProductions

  if numActiveProductions > 0 then
    local minuteFactorTimescaledDt = dt * self.minuteFactorTimescaled * timeAdjust
    local minuteFactorDt = dt / 60000 * timeAdjust

    for n = 1, numActiveProductions do
      local production = self.activeProductions[n]
      local cyclesPerMinuteMinuteFactor = production.cyclesPerMinute * minuteFactorTimescaledDt
      local cyclesPerMinuteFactorNoTimescale = production.cyclesPerMinute * minuteFactorDt
      --Production Revamp: mix-gruppen/boostgruppe hinzufügen und auf false stellen
      local enoughInputResources = true
      local enoughInputMix1 = false
      local enoughInputMix2 = false
      local enoughInputMix3 = false
      local enoughInputMix4 = false
      local enoughInputMix5 = false
      local enoughInputBoost = false
      local enoughOutputSpace = true
      local maxnum = "0"
      local boost = false
      local booster = "1"

      --Production Revamp: Dieser Abschnitt kontrolliert, ob ein /alle notwendigen Inputs in den jeweiligen Gruppe vorhanden sind
      --Production Revamp: Farben hinterlegen für die Rezept-Anzeige, 0=weiß(vorhanden) 1=fehlt(wird benötigt) 2=(optional, nicht vorhanden)
      for x = 1, #production.inputs do
        local input = production.inputs[x]
        local fillLevel = self:getFillLevel(input.type)
        self.inputFillLevels[input] = fillLevel
        local factor = cyclesPerMinuteFactorNoTimescale
        local needamount = input.amount * factor
        local color = 0

        if input.mix == 5 then
          maxnum = "5"
          if fillLevel > needamount then
            enoughInputMix5 = true
          else
           color = 2
          end
        elseif input.mix == 4 then
          if maxnum < "5" then
            maxnum = "4"
          end
          if fillLevel > needamount then
            enoughInputMix4 = true
          else
            color = 2
          end
        elseif input.mix == 3 then
          if maxnum < "4" then
            maxnum = "3"
          end
          if fillLevel > needamount then
            enoughInputMix3 = true
          else
            color = 2
          end
        elseif input.mix == 2 then
          if maxnum < "3" then
            maxnum = "2"
          end
          if fillLevel > needamount then
             enoughInputMix2 = true
          else
            color = 2
          end
        elseif input.mix == 1 then
          if maxnum < "2" then
            maxnum = "1"
          end
          if fillLevel > needamount then
            enoughInputMix1 = true
          else
            color = 2
          end
        elseif input.mix == 6 then
          if fillLevel > needamount then
            boost = true
            booster = booster + input.boostfactor
          else
            color = 2
          end
        elseif fillLevel < needamount then
          color = 1
          enoughInputResources = false
        end
        self:setProductionInputColor(production.id, x, color)
      end

      --Production Revamp: dieser Abschnitt wertet die Ergebnisse der einzelnen Input-Gruppen aus
      if enoughInputResources == true then
        if maxnum == "5" then
          if enoughInputMix5 == false or enoughInputMix4 == false or enoughInputMix3 == false or enoughInputMix2 == false or enoughInputMix1 == false then
            enoughInputResources = false
          end
        elseif maxnum == "4" then
          if enoughInputMix4 == false or enoughInputMix3 == false or enoughInputMix2 == false or enoughInputMix1 == false then
            enoughInputResources = false
          end
        elseif maxnum == "3" then
          if enoughInputMix3 == false or enoughInputMix2 == false or enoughInputMix1 == false then
            enoughInputResources = false
          end
        elseif maxnum == "2" then
          if enoughInputMix2 == false or enoughInputMix1 == false then
            enoughInputResources = false
          end
        elseif maxnum == "1" then
          if enoughInputMix1 == false then
            enoughInputResources = false
          end
        end
      end

      if enoughInputResources == false and self.isOwned then
        if production.status ~= ProductionPoint.PROD_STATUS.MISSING_INPUTS then
          production.status = ProductionPoint.PROD_STATUS.MISSING_INPUTS

          self.owningPlaceable:productionStatusChanged(production, ProductionPoint.PROD_STATUS.MISSING_INPUTS)
          self:setProductionStatus(production.id, production.status)

          break
        end
      end

      if enoughInputResources and self.isOwned then
        for x = 1, #production.outputs do
          local output = production.outputs[x]

          if not output.sellDirectly then
            local freeCapacity = self.storage:getFreeCapacity(output.type)

            --Production Revamp: Erweitert um den booster, um zu Kontrollieren ob genug Platz vorhanden wäre
            if freeCapacity < output.amount * cyclesPerMinuteMinuteFactor * booster then
              enoughOutputSpace = false

              if production.status ~= ProductionPoint.PROD_STATUS.NO_OUTPUT_SPACE then
                production.status = ProductionPoint.PROD_STATUS.NO_OUTPUT_SPACE

                self:setProductionStatus(production.id, production.status)
              end

              break
            end
          end
        end
      end

      if self.isOwned then
        self.productionCostsToClaim = self.productionCostsToClaim + production.costsPerActiveMinute * minuteFactorTimescaledDt
      end

      if not self.isOwned or enoughInputResources and enoughOutputSpace then
        local factor = cyclesPerMinuteMinuteFactor / (self.sharedThroughputCapacity and numActiveProductions or 1)

        --Production Revamp: Dieser Abschnitt entfernt die Verarbeiteten Inputs aus dem Silo
        for y = 1, #production.inputs do
          local input = production.inputs[y]
          local fillLevel = self.inputFillLevels[input]

          if fillLevel > input.amount * cyclesPerMinuteFactorNoTimescale then
            if input.mix == 5 then
              if enoughInputMix5 then
                if self.loadingStation ~= nil then
                  self.loadingStation:removeFillLevel(input.type, input.amount * factor, self.ownerFarmId)
                else
                  self.storage:setFillLevel(fillLevel - input.amount * factor, input.type)
                end
                enoughInputMix5 = false
              end
            elseif input.mix == 4 then
              if enoughInputMix4 then
                if self.loadingStation ~= nil then
                  self.loadingStation:removeFillLevel(input.type, input.amount * factor, self.ownerFarmId)
                else
                  self.storage:setFillLevel(fillLevel - input.amount * factor, input.type)
                end
                enoughInputMix4 = false
              end
            elseif input.mix == 3 then
              if enoughInputMix3 then
                if self.loadingStation ~= nil then
                  self.loadingStation:removeFillLevel(input.type, input.amount * factor, self.ownerFarmId)
                else
                  self.storage:setFillLevel(fillLevel - input.amount * factor, input.type)
                end
                enoughInputMix3 = false
              end
            elseif input.mix == 2 then
              if enoughInputMix2 then
                if self.loadingStation ~= nil then
                  self.loadingStation:removeFillLevel(input.type, input.amount * factor, self.ownerFarmId)
                else
                  self.storage:setFillLevel(fillLevel - input.amount * factor, input.type)
                end
                enoughInputMix2 = false
              end
            elseif input.mix == 1 then
              if enoughInputMix1 then
                if self.loadingStation ~= nil then
                  self.loadingStation:removeFillLevel(input.type, input.amount * factor, self.ownerFarmId)
                else
                  self.storage:setFillLevel(fillLevel - input.amount * factor, input.type)
                end
                enoughInputMix1 = false
              end
            elseif input.mix == 6 then
              if boost then
                if self.loadingStation ~= nil then
                  self.loadingStation:removeFillLevel(input.type, input.amount * factor, self.ownerFarmId)
                else
                  self.storage:setFillLevel(fillLevel - input.amount * factor, input.type)
                end
              end
            else
              if self.loadingStation ~= nil then
                self.loadingStation:removeFillLevel(input.type, input.amount * factor, self.ownerFarmId)
              else
                self.storage:setFillLevel(fillLevel - input.amount * factor, input.type)
              end
            end
          end
        end

        --Production Revamp: Output-Güter dem Silo gutschreiben in Abhängigkeit vom booster, wenn boost nicht deaktiviert wurde für den jeweiligen Filltype
        if self.isOwned then
          --Production Revamp: Umkehrbooster hinterlegen
          local boosterreverse = 1 - (booster - 1)
          if boosterreverse < 0 then
            boosterreverse = 0
          end
          for y = 1, #production.outputs do
            local output = production.outputs[y]
            if output.sellDirectly then
              if self.isServer then
                if output.boost == "true" then
                  self.soldFillTypesToPayOut[output.type] = self.soldFillTypesToPayOut[output.type] + output.amount * factor * booster
                elseif output.boost == "reverse" then
                  self.soldFillTypesToPayOut[output.type] = self.soldFillTypesToPayOut[output.type] + output.amount * factor * boosterreverse
                else
                  self.soldFillTypesToPayOut[output.type] = self.soldFillTypesToPayOut[output.type] + output.amount * factor
                end
              end
            else
              local fillLevel = self.storage:getFillLevel(output.type)
              if output.boost == "true" then
                self.storage:setFillLevel(fillLevel + output.amount * factor * booster, output.type)
              elseif output.boost == "reverse" then
                self.storage:setFillLevel(fillLevel + output.amount * factor * boosterreverse, output.type)
              else
                self.storage:setFillLevel(fillLevel + output.amount * factor, output.type)
              end
            end
          end
        end

        if production.status ~= ProductionPoint.PROD_STATUS.RUNNING then
          production.status = ProductionPoint.PROD_STATUS.RUNNING

          self.owningPlaceable:productionStatusChanged(production, production.status)
          ProductionPointProductionStatusEvent.sendEvent(self, production.id, production.status)
        end

        table.clear(self.inputFillLevels)
      end
    end
  end

  if self.isServer and self.isOwned and self.palletSpawnCooldown < g_time then
    for fillTypeId, pallet in pairs(self.outputFillTypeIdsToPallets) do
      if self.outputFillTypeIdsDirectSell[fillTypeId] == nil and self.outputFillTypeIdsAutoDeliver[fillTypeId] == nil and self.outputFillTypeIdsStorage[fillTypeId] == nil then
        local fillLevel = self.storage:getFillLevel(fillTypeId)

        if fillLevel > 0 and pallet and pallet.capacity <= fillLevel and not self.waitingForPalletToSpawn then
          self.waitingForPalletToSpawn = true

          self.palletSpawner:spawnPallet(self:getOwnerFarmId(), fillTypeId, self.palletSpawnRequestCallback, self)
        end
      end
    end
  end

  self.lastUpdatedTime = g_time
end

ProductionPoint.updateProduction = Utils.overwrittenFunction(ProductionPoint.updateProduction, Revamp.updateProduction)
print("Production Revamp: ProductionPoint Update overwritten")



--Production Revamp: Überschrieben um den Output-Mode auf "Einlagern" setzen zu können
function Revamp:setOutputDistributionMode(superFunc, outputFillTypeId, mode, noEventSend)
  if self.outputFillTypeIds[outputFillTypeId] == nil then
    printf("Error: setOutputDistribution(): fillType '%s' is not an output fillType", g_fillTypeManager:getFillTypeNameByIndex(outputFillTypeId))

    return
  end

  mode = tonumber(mode)
  self.outputFillTypeIdsDirectSell[outputFillTypeId] = nil
  self.outputFillTypeIdsAutoDeliver[outputFillTypeId] = nil
  --Production Revamp: Alle Filltypes generell auf nil setzen für die Storage-Liste
  self.outputFillTypeIdsStorage[outputFillTypeId] = nil
  --Production Revamp: CoolDown für den Palettenspawner, damit nicht versehentlich Paletten gespawnt werden beim Umschalten
  self.palletSpawnCooldown = g_time + 4000
  
  if mode == ProductionPoint.OUTPUT_MODE.DIRECT_SELL then
    self.outputFillTypeIdsDirectSell[outputFillTypeId] = true
  elseif mode == ProductionPoint.OUTPUT_MODE.AUTO_DELIVER then
    self.outputFillTypeIdsAutoDeliver[outputFillTypeId] = true
  --Production Revamp: Sollte ein Output auf "Einlagern" stehen, Filltype in der Liste hinterlegen
  elseif mode == ProductionPoint.OUTPUT_MODE.STORE then
    self.outputFillTypeIdsStorage[outputFillTypeId] = true
  elseif mode ~= ProductionPoint.OUTPUT_MODE.KEEP then
    printf("Error: setOutputDistribution(): Undefined mode '%s'", mode)

    return
  end

  ProductionPointOutputModeEvent.sendEvent(self, outputFillTypeId, mode, noEventSend)
end

ProductionPoint.setOutputDistributionMode = Utils.overwrittenFunction(ProductionPoint.setOutputDistributionMode, Revamp.setOutputDistributionMode)



--Production Revamp: Überschrieben um den Output-Mode auf "Einlagern" auslesen zu können
function Revamp:getOutputDistributionMode(superFunc, outputFillTypeId)
  if self.outputFillTypeIdsDirectSell[outputFillTypeId] ~= nil then
    return ProductionPoint.OUTPUT_MODE.DIRECT_SELL
  elseif self.outputFillTypeIdsAutoDeliver[outputFillTypeId] ~= nil then
    return ProductionPoint.OUTPUT_MODE.AUTO_DELIVER
  --Production Revamp: Hinzugefügt um Outputs auf Einlagern stellen zu können
  elseif self.outputFillTypeIdsStorage[outputFillTypeId] ~= nil then
    return ProductionPoint.OUTPUT_MODE.STORE
  end

  return ProductionPoint.OUTPUT_MODE.KEEP
end

ProductionPoint.getOutputDistributionMode = Utils.overwrittenFunction(ProductionPoint.getOutputDistributionMode, Revamp.getOutputDistributionMode)
print("Production Revamp: ProductionPoint Set & Get DistributionMode Overwritten")



--Production Revamp: LoadFromXML überschrieben um die "Einlagern" Option aus dem Savegame laden zu können, Erweitert um die Prioritäten für Inputs aus dem Savegame laden zu können
function Revamp:loadFromXMLFile(superFunc, xmlFile, key)
  local palletSpawnCooldown = xmlFile:getValue(key .. "#palletSpawnCooldown")

  if palletSpawnCooldown then
    self.palletSpawnCooldown = g_time + palletSpawnCooldown
  end

  self.productionCostsToClaim = xmlFile:getValue(key .. "#productionCostsToClaim") or self.productionCostsToClaim

  if self.owningPlaceable.ownerFarmId == AccessHandler.EVERYONE then
    for n = 1, #self.productions do
      self:setProductionState(self.productions[n].id, true)
    end
  end

  xmlFile:iterate(key .. ".production", function (index, productionKey)
    local prodId = xmlFile:getValue(productionKey .. "#id")
    local isEnabled = xmlFile:getValue(productionKey .. "#isEnabled")

    if self.productionsIdToObj[prodId] == nil then
      Logging.xmlWarning(xmlFile, "Unknown production id '%s'", prodId)
    else
      self:setProductionState(prodId, isEnabled)
    end
  end)
  
  --Production Revamp: Alle Filltype auf Auslagern stellen, damit diese anschließend aus dem Savegame richtig geladen werden
  for fillType in pairs(self.outputFillTypeIds) do
    self:setOutputDistributionMode(fillType, ProductionPoint.OUTPUT_MODE.KEEP)
  end
  
  xmlFile:iterate(key .. ".directSellFillType", function (index, directSellKey)
    local fillType = g_fillTypeManager:getFillTypeIndexByName(xmlFile:getValue(directSellKey))

    if fillType then
      self:setOutputDistributionMode(fillType, ProductionPoint.OUTPUT_MODE.DIRECT_SELL)
    end
  end)
  
  xmlFile:iterate(key .. ".autoDeliverFillType", function (index, autoDeliverKey)
    local fillType = g_fillTypeManager:getFillTypeIndexByName(xmlFile:getValue(autoDeliverKey))

    if fillType then
      self:setOutputDistributionMode(fillType, ProductionPoint.OUTPUT_MODE.AUTO_DELIVER)
    end
  end)

  --Production Revamp: Hinzugefügt um die "Einlagern" Option aus dem Savegame laden zu können
  xmlFile:iterate(key .. ".storageFillType", function (index, storageKey)
    local fillType = g_fillTypeManager:getFillTypeIndexByName(xmlFile:getValue(storageKey))

    if fillType then
      self:setOutputDistributionMode(fillType, ProductionPoint.OUTPUT_MODE.STORE)
    end
  end)

  --Production Revamp: Hinzugefügt um die Prioritäten für Inputs aus dem Savegame laden zu können
  xmlFile:iterate(key .. ".priorityFillType", function (index, priorityKey)
    local priorityType = xmlFile:getValue(priorityKey)
    local split = string.split(priorityType, " ")  
    local fillType = g_fillTypeManager:getFillTypeIndexByName(split[1])
    local priority = tonumber(split[2])
    if fillType then
      self:setInputPriority(fillType, priority)
    end
  end)

  if not self.storage:loadFromXMLFile(xmlFile, key .. ".storage") then
    return false
  end

  return true
end

ProductionPoint.loadFromXMLFile = Utils.overwrittenFunction(ProductionPoint.loadFromXMLFile, Revamp.loadFromXMLFile)



--Production Revamp: SaveToXML überschrieben um die Einstellung "Einlagern" speichern zu können
function Revamp:saveToXMLFile(superFunc, xmlFile, key, usedModNames)
  if g_time < self.palletSpawnCooldown then
    xmlFile:setValue(key .. "#palletSpawnCooldown", self.palletSpawnCooldown - g_time)
  end

  if self.productionCostsToClaim ~= 0 then
    xmlFile:setValue(key .. "#productionCostsToClaim", self.productionCostsToClaim)
  end

  local xmlIndex = 0

  for i = 1, #self.activeProductions do
    local production = self.activeProductions[i]
    local productionKey = string.format("%s.production(%i)", key, xmlIndex)

    xmlFile:setValue(productionKey .. "#id", production.id)
    xmlFile:setValue(productionKey .. "#isEnabled", true)

    xmlIndex = xmlIndex + 1
  end

  xmlFile:setTable(key .. ".directSellFillType", self.outputFillTypeIdsDirectSell, function (fillTypeKey, _, fillTypeId)
    local fillType = g_fillTypeManager:getFillTypeNameByIndex(fillTypeId)

    xmlFile:setValue(fillTypeKey, fillType)
  end)
  xmlFile:setTable(key .. ".autoDeliverFillType", self.outputFillTypeIdsAutoDeliver, function (fillTypeKey, _, fillTypeId)
    local fillType = g_fillTypeManager:getFillTypeNameByIndex(fillTypeId)

    xmlFile:setValue(fillTypeKey, fillType)
  end)
  --Production Revamp: Hinzugefügt um die "Einlagern" Option Speichern zu können
  xmlFile:setTable(key .. ".storageFillType", self.outputFillTypeIdsStorage, function (fillTypeKey, _, fillTypeId)
    local fillType = g_fillTypeManager:getFillTypeNameByIndex(fillTypeId)

    xmlFile:setValue(fillTypeKey, fillType)
  end)

  --Production Revamp: Hinzugefügt um Prioritäten speichern zu können
  xmlFile:setTable(key .. ".priorityFillType", self.inputFillTypeIdsPriority, function (fillTypeKey, _, fillTypeId)
    local fillType = g_fillTypeManager:getFillTypeNameByIndex(fillTypeId)
    local priority = self.inputFillTypeIdsPriority[fillTypeId]
    fillType = fillType .. " " .. priority

    xmlFile:setValue(fillTypeKey, fillType)
  end)

  self.storage:saveToXMLFile(xmlFile, key .. ".storage", usedModNames)
end

ProductionPoint.saveToXMLFile = Utils.overwrittenFunction(ProductionPoint.saveToXMLFile, Revamp.saveToXMLFile)
print("Production Revamp: Production Point Load and Save XML overwritten")



--Production Revamp: readStream überschrieben um die Einlagern-Funktion, Prioritäten und Farb-Rezepte im Multiplayer synchronisieren zu können
function Revamp:readStream(superFunc, streamId, connection)
  ProductionPoint:superClass().readStream(self, streamId, connection)

  if connection:getIsServer() then
    for i = 1, streamReadUInt8(streamId) do
      self:setOutputDistributionMode(streamReadUIntN(streamId, FillTypeManager.SEND_NUM_BITS), ProductionPoint.OUTPUT_MODE.DIRECT_SELL)
    end

    for i = 1, streamReadUInt8(streamId) do
      self:setOutputDistributionMode(streamReadUIntN(streamId, FillTypeManager.SEND_NUM_BITS), ProductionPoint.OUTPUT_MODE.AUTO_DELIVER)
    end

    --Production Revamp: Neue Option "Einlagern" hinzugefügt
    for i = 1, streamReadUInt8(streamId) do
      self:setOutputDistributionMode(streamReadUIntN(streamId, FillTypeManager.SEND_NUM_BITS), ProductionPoint.OUTPUT_MODE.STORE)
    end

    --Production Revamp: Input-Prioritäten hinzugefügt
    for i = 1, streamReadUInt8(streamId) do
      local fillType = streamReadUIntN(streamId, FillTypeManager.SEND_NUM_BITS)
      local priority = streamReadUIntN(streamId, 6)
      self:setInputPriority(fillType, priority)
    end

    local unloadingStationId = NetworkUtil.readNodeObjectId(streamId)

    self.unloadingStation:readStream(streamId, connection)
    g_client:finishRegisterObject(self.unloadingStation, unloadingStationId)

    if self.loadingStation ~= nil then
      local loadingStationId = NetworkUtil.readNodeObjectId(streamId)

      self.loadingStation:readStream(streamId, connection)
      g_client:finishRegisterObject(self.loadingStation, loadingStationId)
    end

    local storageId = NetworkUtil.readNodeObjectId(streamId)

    self.storage:readStream(streamId, connection)
    g_client:finishRegisterObject(self.storage, storageId)

    for i = 1, streamReadUInt8(streamId) do
      local productionId = streamReadString(streamId)

      self:setProductionState(productionId, true)
      self:setProductionStatus(productionId, streamReadUIntN(streamId, ProductionPoint.PROD_STATUS_NUM_BITS))

      for x = 1, streamReadUInt8(streamId) do
        local productionId = streamReadString(streamId)
        local inputId = streamReadUIntN(streamId, FillTypeManager.SEND_NUM_BITS)
        local productionInputColor = streamReadUIntN(streamId, FillTypeManager.SEND_NUM_BITS)
        self:setProductionInputColor(productionId, inputId, productionInputColor)
      end
    end

    self.palletLimitReached = streamReadBool(streamId)
  end
end

ProductionPoint.readStream = Utils.overwrittenFunction(ProductionPoint.readStream, Revamp.readStream)



--Production Revamp: writeStream überschrieben um die Einlagern-Funktion, Prioritäten und Farb-Rezepte im Multiplayer synchronisieren zu können
function Revamp:writeStream(superFunc, streamId, connection)
  ProductionPoint:superClass().writeStream(self, streamId, connection)

  if not connection:getIsServer() then
    streamWriteUInt8(streamId, table.size(self.outputFillTypeIdsDirectSell))

    for directSellFillTypeId in pairs(self.outputFillTypeIdsDirectSell) do
      streamWriteUIntN(streamId, directSellFillTypeId, FillTypeManager.SEND_NUM_BITS)
    end

    streamWriteUInt8(streamId, table.size(self.outputFillTypeIdsAutoDeliver))

    for autoDeliverFillTypeId in pairs(self.outputFillTypeIdsAutoDeliver) do
      streamWriteUIntN(streamId, autoDeliverFillTypeId, FillTypeManager.SEND_NUM_BITS)
    end

    --Production Revamp: Neue Option "Einlagern" hinzugefügt
    streamWriteUInt8(streamId, table.size(self.outputFillTypeIdsStorage))

    for autoStorageFillTypeId in pairs(self.outputFillTypeIdsStorage) do
      streamWriteUIntN(streamId, autoStorageFillTypeId, FillTypeManager.SEND_NUM_BITS)
    end
  
    --Production Revamp: Input-Prioritäten hinzugefügt
    streamWriteUInt8(streamId, table.size(self.inputFillTypeIdsPriority))

    for inputFillType in pairs(self.inputFillTypeIdsPriority) do
      local priority = self.inputFillTypeIdsPriority[inputFillType]
      streamWriteUIntN(streamId, inputFillType, FillTypeManager.SEND_NUM_BITS)
      streamWriteUIntN(streamId, priority, 6)
    end
  
    NetworkUtil.writeNodeObjectId(streamId, NetworkUtil.getObjectId(self.unloadingStation))
    self.unloadingStation:writeStream(streamId, connection)
    g_server:registerObjectInStream(connection, self.unloadingStation)

    if self.loadingStation ~= nil then
      NetworkUtil.writeNodeObjectId(streamId, NetworkUtil.getObjectId(self.loadingStation))
      self.loadingStation:writeStream(streamId, connection)
      g_server:registerObjectInStream(connection, self.loadingStation)
    end

    NetworkUtil.writeNodeObjectId(streamId, NetworkUtil.getObjectId(self.storage))
    self.storage:writeStream(streamId, connection)
    g_server:registerObjectInStream(connection, self.storage)
    streamWriteUInt8(streamId, #self.activeProductions)

    for i = 1, #self.activeProductions do
      local production = self.activeProductions[i]

      streamWriteString(streamId, production.id)
      streamWriteUIntN(streamId, production.status, ProductionPoint.PROD_STATUS_NUM_BITS)

      streamWriteUInt8(streamId, #production.inputs)
      for x = 1, #production.inputs do
        local productionInputColor = production.inputs[x].color
        local inputId = x
        streamWriteString(streamId, production.id)
        streamWriteUIntN(streamId, inputId, FillTypeManager.SEND_NUM_BITS)
        streamWriteUIntN(streamId, productionInputColor, FillTypeManager.SEND_NUM_BITS)
      end
    end

    streamWriteBool(streamId, self.palletLimitReached)
  end
end

ProductionPoint.writeStream = Utils.overwrittenFunction(ProductionPoint.writeStream, Revamp.writeStream)
print("Production Revamp: Production Point Write/Read Stream Overwritten")



--Production Revamp: updateDetails überarbeitet um neue Darstellung der Rezepte zu ermöglichen
function Revamp:updateDetails(superFunc)
  local production = self:getSelectedProduction()
  local status = production.status
  local statusKey = ProductionPoint.PROD_STATUS_TO_L10N[production.status] or "unknown"
  local statusProfile = "ingameMenuProductionDetailValue"

  if status == ProductionPoint.PROD_STATUS.MISSING_INPUTS then
    statusProfile = "ingameMenuProductionDetailValueError"
  elseif status == ProductionPoint.PROD_STATUS.NO_OUTPUT_SPACE then
    statusProfile = "ingameMenuProductionDetailValueError"
  end

  self.detailProductionStatus:applyProfile(statusProfile)
  self.detailProductionStatus:setLocaKey(statusKey)
  self.detailCyclesPerMonth:setText(MathUtil.round(production.cyclesPerMonth, 2))
  self.detailCostsPerMonth:setValue(production.costsPerActiveMonth)
  local maxboost = 0

  --Production Revamp: local function für die Output-Seite vom Rezept, berücksichtigend boost-Inputs, Zeilenumbruch und Farbanzeige abhängig von Booster
  local function createOutputRecipe(list, layout, newline)
    for i = 1, #layout.elements do
      layout.elements[1]:delete()
    end

    for index, item in ipairs(list) do
      if index > 1 then
        self.recipePlus:clone(layout)
      end
      local count = self.recipeText:clone(layout)
      if maxboost > 0 then
        local bamount = item.amount
        if item.boost == "true" then
          bamount = bamount * (1 + maxboost)
        elseif item.boost == "reverse" then
          bamount = bamount * (1 - maxboost)
        end
        count:setText(g_i18n:formatNumber(bamount, 2))

        local fillType = g_fillTypeManager:getFillTypeByIndex(item.type)
        local icon = self.recipeFillIcon:clone(layout)

        icon:setImageFilename(fillType.hudOverlayFilename)

        if item.boost == "true" then
          local count = self.recipeText:clone(layout)
          count:setText( "(= " .. g_i18n:formatNumber((maxboost + 1)*100, 2) .. "%) ")
          count:setTextColor(0.9157, 0.1420, 0.0002, 1)
        elseif item.boost == "reverse" then
      local rbooster = 1 - maxboost
      if rbooster < 0 then
        rbooster = 0
      end
          local count = self.recipeText:clone(layout)
          count:setText( "(= " .. g_i18n:formatNumber(rbooster*100, 2) .. "%) ")
          count:setTextColor(0.9157, 0.1420, 0.0002, 1)
        end
      else
        count:setText(g_i18n:formatNumber(item.amount, 2))
        local fillType = g_fillTypeManager:getFillTypeByIndex(item.type)
        local icon = self.recipeFillIcon:clone(layout)

        icon:setImageFilename(fillType.hudOverlayFilename)
      end
    end
    if newline then
      self.recipePlus:clone(layout)
    end
  end

  --Production Revamp: local function für die Input-Seite vom Rezept, berücksichtigend boost- und mix-Inputs, Zeilenumbruch und Farbanzeige Abhängig von Verfügbarkeit
  local function createInputRecipe(list, layout, mixIndex, newline)
    for i = 1, #layout.elements do
      layout.elements[1]:delete()
    end

    for index, item in ipairs(list) do
      if index > 1 then
        if mixIndex == 1 then
           self.recipePlus:clone(layout)
        else
          local count = self.recipeText:clone(layout)
          count:setText(" || ")
        end
      end

      local count = self.recipeText:clone(layout)
      count:setText(g_i18n:formatNumber(item.amount, 2))
      if item.color == 1 then
        count:setTextColor(1, 0, 0, 1)
      elseif item.color == 2 then
        count:setTextColor(0.9157, 0.1420, 0.0002, 1)
      end
      local fillType = g_fillTypeManager:getFillTypeByIndex(item.type)
      local icon = self.recipeFillIcon:clone(layout)

      if mixIndex == 7 then
        local count = self.recipeText:clone(layout)
        count:setText( "(+ " .. g_i18n:formatNumber(item.boostfactor*100, 2) .. "%) ")
        if item.color == 2 then
          count:setTextColor(0.9157, 0.1420, 0.0002, 1)
        else
          maxboost = maxboost + item.boostfactor
        end
      end

      icon:setImageFilename(fillType.hudOverlayFilename)
    end
    if newline then
      if mixIndex == 1 then
         self.recipePlus:clone(layout)
      else
        local count = self.recipeText:clone(layout)
        count:setText(" || ")
      end
    end
  end

    --Production Revamp: detailsBox resetten um alte Rezepte zu löschen
  for i = #self.detailsBox.elements, 1, -1 do
    if i >= 12 then
      if self.detailsBox.elements[i] ~= nil then
        self.detailsBox.elements[i]:delete()
      end
    end
  end

  --Production Revamp: ProduktionsInputs auslesen und in sortierte Listen speichern abhängig von ihrer Gruppe
  local InputList = {}
  InputList[1] = {}
  InputList[2] = {}
  InputList[3] = {}
  InputList[4] = {}
  InputList[5] = {}
  InputList[6] = {}
  InputList[7] = {}
  local item = {}
  for index, item in ipairs(production.inputs) do
    local insert = item.mix +1
    local myListItem = InputList[insert]
    table.insert(myListItem, item)
  end

  --Production Revamp: Rezept-Übersicht erstellen, Input Seite
  local lineCounter = 0
  local outputmax = 4
  for mixIndex, list in pairs(InputList) do
    if list ~= nil and #list ~= 0 then 

      --Production Revamp: PlusZeichen zwischen zwei Zutaten-Listen, ausgenommen erste Zeile
      if lineCounter ~= 0 then
        local myElement = FlowLayoutElement.new()
        myElement:copyAttributes(self.detailRecipeInputLayout)
        myElement.absPosition[2] = self.detailRecipeInputLayout.absPosition[2] - (self.detailRecipeInputLayout.absSize[2] * (lineCounter))

        lineCounter = lineCounter + 1
        self.recipePlus:clone(myElement)
        self.detailsBox:addElement(myElement)
        myElement:invalidateLayout()
      end

      --Production Revamp: Zeilenumbruch nach 4 bzw. 2 Inputs durch Aufteilen der Listen
      local recipePuffer = {}
      local recipemax = 4
      if mixIndex == 7 then
        recipemax = 2
        outputmax = 2
      end
      local numList = #list
      for index, item in ipairs(list) do
      table.insert(recipePuffer, item)
      if #recipePuffer == recipemax then
        local myElement = FlowLayoutElement.new()
        myElement:copyAttributes(self.detailRecipeInputLayout)
        myElement.absPosition[2] = self.detailRecipeInputLayout.absPosition[2] - (self.detailRecipeInputLayout.absSize[2] * (lineCounter))

        lineCounter = lineCounter + 1
        if numList > recipemax then
          createInputRecipe(recipePuffer, myElement, mixIndex, true)
        else
          createInputRecipe(recipePuffer, myElement, mixIndex, false)
        end
        self.detailsBox:addElement(myElement)

        myElement:invalidateLayout()  
        recipePuffer = {}
      end
    end

      --Production Revamp: sollte der Puffer nicht leer sein, letzte Input-Zeile generieren
      if #recipePuffer > 0 then
        local myElement = FlowLayoutElement.new()
        myElement:copyAttributes(self.detailRecipeInputLayout)
        myElement.absPosition[2] = self.detailRecipeInputLayout.absPosition[2] - (self.detailRecipeInputLayout.absSize[2] * (lineCounter))

        lineCounter = lineCounter + 1
        createInputRecipe(recipePuffer, myElement, mixIndex, false)
        self.detailsBox:addElement(myElement)

        myElement:invalidateLayout()  
      end
    end
  end

 --Production Revamp: Ergebniss-Pfeil verschieben
  self.detailsBox.elements[10].absPosition[2] = self.detailRecipeInputLayout.absPosition[2] - (self.detailRecipeInputLayout.absSize[2] * lineCounter)
  lineCounter = lineCounter + 1

  --Production Revamp: Rezept-Übersicht erstellen, Output Seite
  local numOutput = #production.outputs
  local outputPuffer = {}
  for index, item in ipairs(production.outputs) do
    table.insert(outputPuffer, item)

    --Production Revamp: Zeilenumbruch nach 4 bzw. 2 Inputs durch Aufteilen der Listen
    if #outputPuffer == outputmax then
      local myElement = FlowLayoutElement.new()
      myElement:copyAttributes(self.detailRecipeOutputLayout)
      myElement.absPosition[2] = self.detailRecipeInputLayout.absPosition[2] - (self.detailRecipeInputLayout.absSize[2] * lineCounter)

      lineCounter = lineCounter + 1
      if numOutput > outputmax then
        createOutputRecipe(outputPuffer, myElement, true)
      else
        createOutputRecipe(outputPuffer, myElement, false)
      end

      self.detailsBox:addElement(myElement)

      myElement:invalidateLayout()
      outputPuffer = {}
    end
  end

  --Production Revamp: sollte der Puffer nicht leer sein, letzte Output-Zeile generieren
  if #outputPuffer > 0 then
    local myElement = FlowLayoutElement.new()
    myElement:copyAttributes(self.detailRecipeOutputLayout)
    myElement.absPosition[2] = self.detailRecipeInputLayout.absPosition[2] - (self.detailRecipeInputLayout.absSize[2] * lineCounter)

    createOutputRecipe(outputPuffer, myElement, false)
    self.detailsBox:addElement(myElement)

    myElement:invalidateLayout()
  end

  self.storageList:reloadData()
end

InGameMenuProductionFrame.updateDetails = Utils.overwrittenFunction(InGameMenuProductionFrame.updateDetails, Revamp.updateDetails)
print("Production Revamp: Gui Overwritten #2")



--Production Revamp: Production GUI überschrieben um Füllstände, Einlagern und Input-Priority anzeigen zu können
function Revamp:populateCellForItemInSection(superFunc, list, section, index, cell)
  if list == self.productionList then
    local productionPoint = self:getProductionPoints()[section]
    local production = productionPoint.productions[index]
    local fillTypeDesc = g_fillTypeManager:getFillTypeByIndex(production.primaryProductFillType)

    if fillTypeDesc ~= nil then
      cell:getAttribute("icon"):setImageFilename(fillTypeDesc.hudOverlayFilename)
    end

    cell:getAttribute("icon"):setVisible(fillTypeDesc ~= nil)
    cell:getAttribute("name"):setText(production.name or fillTypeDesc.title)

    local status = production.status
    local activityElement = cell:getAttribute("activity")

    if status == ProductionPoint.PROD_STATUS.RUNNING then
      activityElement:applyProfile("ingameMenuProductionProductionActivityActive")
    elseif status == ProductionPoint.PROD_STATUS.MISSING_INPUTS or status == ProductionPoint.PROD_STATUS.NO_OUTPUT_SPACE then
      activityElement:applyProfile("ingameMenuProductionProductionActivityIssue")
    else
      activityElement:applyProfile("ingameMenuProductionProductionActivity")
    end
  else
    local _, productionPoint = self:getSelectedProduction()
    local fillType, isInput = nil

    if section == 1 then
      fillType = self.selectedProductionPoint.inputFillTypeIdsArray[index]
      isInput = true
    else
      fillType = self.selectedProductionPoint.outputFillTypeIdsArray[index]
      isInput = false
    end

    if fillType ~= FillType.UNKNOWN then
      local fillLevel = self.selectedProductionPoint:getFillLevel(fillType)
      local capacity = self.selectedProductionPoint:getCapacity(fillType)
      local fillTypeDesc = g_fillTypeManager:getFillTypeByIndex(fillType)

      cell:getAttribute("icon"):setImageFilename(fillTypeDesc.hudOverlayFilename)
      cell:getAttribute("fillType"):setText(fillTypeDesc.title)
      --Production Revamp: Abgeändert um das Maximal Volumen anzeigen zu können
      cell:getAttribute("fillLevel"):setText(self.i18n:formatVolume(fillLevel, 0) .. " / " .. self.i18n:formatVolume(capacity, 0))

      if not isInput then
        local outputMode = productionPoint:getOutputDistributionMode(fillType)
        local outputModeText = g_i18n:getText("Revamp_Spawn")

        if outputMode == ProductionPoint.OUTPUT_MODE.DIRECT_SELL then
          outputModeText = self.i18n:getText("ui_production_output_selling")
        elseif outputMode == ProductionPoint.OUTPUT_MODE.AUTO_DELIVER then
          outputModeText = self.i18n:getText("ui_production_output_distributing")
        --Production Revamp: Hinzugefügt um die "Einlagern" Option anzeigen zu können
        elseif outputMode == ProductionPoint.OUTPUT_MODE.STORE then
          outputModeText = g_i18n:getText("Revamp_Store")
        end

        cell:getAttribute("outputMode"):setText(outputModeText)
      else
        --Production Revamp: Hinzugefügt um Prioritäten anzeigen zu können
        local priority = productionPoint:getInputPriority(fillType)
        local outputModeText = g_i18n:getText("Revamp_DeliveryPriority")
        outputModeText = outputModeText.. ": " ..priority
        if priority <= 0 then
          outputModeText = g_i18n:getText("Revamp_DeliveryPriorityDeactivated")
        end
          cell:getAttribute("outputMode"):setText(outputModeText)
        end

      self:setStatusBarValue(cell:getAttribute("bar"), fillLevel / capacity, isInput)
    end
  end
end

InGameMenuProductionFrame.populateCellForItemInSection = Utils.overwrittenFunction(InGameMenuProductionFrame.populateCellForItemInSection, Revamp.populateCellForItemInSection)
print("Production Revamp: Production Gui overwritten #1")



--Production Revamp: II oder Y hinzufügen sollte sharedThroughputCapacity aktiv sein
function Revamp:getName(superFunc, revamp)
  local name = nil
    if self.name ~= nil then
    name = self.name
  else
    name = self.owningPlaceable:getName()
  end
  if revamp then
    if self.sharedThroughputCapacity == true then
      name = name .. "    -  Y"
    else
      name = name .. "    -  II"
    end
  end
  return name
end

ProductionPoint.getName = Utils.overwrittenFunction(ProductionPoint.getName, Revamp.getName)



--Production Revamp: Nötig um sharedThroughputCapacity anzeigen zu können
function Revamp:getTitleForSectionHeader(superFunc, list, section)
  if list == self.productionList then
    local productionPoint = self:getProductionPoints()[section]

    return productionPoint:getName(true)
  elseif section == 1 then
    return g_i18n:getText("ui_productions_incomingMaterials")
  else
    return g_i18n:getText("ui_productions_outgoingProducts")
  end
end

InGameMenuProductionFrame.getTitleForSectionHeader = Utils.overwrittenFunction(InGameMenuProductionFrame.getTitleForSectionHeader, Revamp.getTitleForSectionHeader)
print("Production Revamp: Production Gui overwritten #2")



--Production Revamp: addFillLevel neu geschrieben, um Produktionen als Verkaufspunkte zu erhalten/Missionsgüter nicht im Lager zu haben
function Revamp:addFillLevelFromTool(superFunc, farmId, deltaFillLevel, fillType, fillInfo, toolType, extraAttributes)
  local movedFillLevel = 0
  if deltaFillLevel > 0 then
    --Mission Abfragen
    local usedByMission = false
    for _, mission in pairs(self.missions) do
      if mission.fillSold ~= nil and mission.fillType == fillType and mission.farmId == farmId then
        mission:fillSold(deltaFillLevel)
        usedByMission = true

        break
      end
    end

    --Überprüfen ob Filltype im Lager angenommen wird
    if self:getIsFillTypeAllowed(fillType, extraAttributes) then
      --Sollte eine Mission für die Produktion aktiv sein
      if usedByMission then
        movedFillLevel = deltaFillLevel
      else
        --Überprüfen ob es sich um eine Produktion handelt
        if self.storeSoldGoods then
          --Besitzer-ID der Produktion ermitteln & Lohnerstatus auslesen
          local ownerFarmId = self.owningPlaceable:getOwnerFarmId()
          local testLohn = AccessHandler:canFarmAccessOtherId(farmId, ownerFarmId)

          --Sollte die Porduktion dem Ablader gehören
          if ownerFarmId == farmId then
            movedFillLevel = SellingStation:superClass().addFillLevelFromTool(self, farmId, deltaFillLevel, fillType, fillInfo, toolType, extraAttributes)
          --Sollte die Produktionen jemand anderes gehören oder niemanden
          elseif ownerFarmId ~= farmId and ownerFarmId ~= 0 then
           --sollte Lohnerstatus vorhanden sein
            if testLohn then
              movedFillLevel = SellingStation:superClass().addFillLevelFromTool(self, farmId, deltaFillLevel, fillType, fillInfo, toolType, extraAttributes)
            else
              movedFillLevel = deltaFillLevel
              self:sellFillType(farmId, movedFillLevel, fillType, toolType, extraAttributes)    
            end
          else
            movedFillLevel = deltaFillLevel
            self:sellFillType(farmId, movedFillLevel, fillType, toolType, extraAttributes)
          end
        else
          movedFillLevel = deltaFillLevel
          self:sellFillType(farmId, movedFillLevel, fillType, toolType, extraAttributes)
          self:startFx(fillType)
        end
      end
    end
  end

  return movedFillLevel
end

SellingStation.addFillLevelFromTool = Utils.overwrittenFunction(SellingStation.addFillLevelFromTool, Revamp.addFillLevelFromTool)
print("Production Revamp: Missionfix - SellingStation overwritten")



--Production Revamp: Einbau Intelligentes Verteilen nach Prioritäten & Eingeschalteten Produktionen + Bugfix Verteil-Kosten
function Revamp:distributeGoods()
  if not self.isServer then
    return
  end

  for _, farmTable in pairs(self.farmIds) do
    for i = 1, #farmTable.productionPoints do
      local distributingProdPoint = farmTable.productionPoints[i]

      for fillTypeIdToDistribute in pairs(distributingProdPoint.outputFillTypeIdsAutoDeliver) do
        local amountToDistribute = distributingProdPoint.storage:getFillLevel(fillTypeIdToDistribute)

        if amountToDistribute > 0 then
          local prodPointsInDemand = farmTable.inputTypeToProductionPoints[fillTypeIdToDistribute] or {}

          --Production Revamp: Verteilen als eigene Funktion abhängig von der eingestellten Priorität der Belieferung
          local function distributePriority(priority, amountToDistribute, prodPointsInDemand, fillTypeIdToDistribute, distributingProdPoint)
          local remainingAmount = amountToDistribute
          local totalFreeCapacity = 0
          for n = 1, #prodPointsInDemand do
            --Production Revamp: Nur aktive Produktionen sollen beliefert werden, dafür werden die einzelnen Produktionslinien kontrolliert, ob sie nicht Inaktiv sind, Berechnung der Freien Kapazität
            local rproductions = prodPointsInDemand[n].productions
            local running = false

            --Production Revamp: Jede Produktionslinie in jeder Produktion durchsuchen ob diese nicht INACTIVE ist
            for g = 1, #rproductions do
              local lproductions = rproductions[g]
              if rproductions[g].status ~= ProductionPoint.PROD_STATUS.INACTIVE then
                --Production Revamp: Nur dann Verteilen wenn auch die Produktionslinie selber aktiv ist und nicht nur Lagerplatz vorhanden
                for u = 1, #lproductions.inputs do
                  local input = lproductions.inputs[u]
                  if input.type == fillTypeIdToDistribute then
                    running = true
                  end
                end
              end
            end
            if prodPointsInDemand[n].inputFillTypeIdsPriority[fillTypeIdToDistribute] == priority and running then
              totalFreeCapacity = totalFreeCapacity + prodPointsInDemand[n].storage:getFreeCapacity(fillTypeIdToDistribute, true)
            end
          end

          if totalFreeCapacity > 0 then
            for n = 1, #prodPointsInDemand do
              local prodPointInDemand = prodPointsInDemand[n]
              local maxAmountToReceive = prodPointInDemand.storage:getFreeCapacity(fillTypeIdToDistribute, true)

              if maxAmountToReceive > 0 then
                --Production Revamp: Nur aktive Produktionen sollen beliefert werden, dafür werden die einzelnen Produktionslinien kontrolliert, ob sie nicht Inaktiv sind, Verteilen auf die Lager
                local rproductions = prodPointsInDemand[n].productions
                local running = false
                for g = 1, #rproductions do
                  local lproductions = rproductions[g]
                  if rproductions[g].status ~= ProductionPoint.PROD_STATUS.INACTIVE then
                    for u = 1, #lproductions.inputs do
                      local input = lproductions.inputs[u]
                      if input.type == fillTypeIdToDistribute then
                        running = true
                      end
                    end
                  end
                end

                if prodPointsInDemand[n].inputFillTypeIdsPriority[fillTypeIdToDistribute] == priority and running then
                  local amountToTransfer = math.min(maxAmountToReceive, amountToDistribute * maxAmountToReceive / totalFreeCapacity)
                  remainingAmount = remainingAmount - amountToTransfer
                  local distanceSourceToTarget = calcDistanceFrom(distributingProdPoint.owningPlaceable.rootNode, prodPointInDemand.owningPlaceable.rootNode)
                  local transferCosts = amountToTransfer * distanceSourceToTarget * ProductionPoint.DIRECT_DELIVERY_PRICE

                  --Production Revamp: Verteilen kostet Geld, es bringt keins...
                  g_currentMission:addMoney(-transferCosts, prodPointInDemand.ownerFarmId, MoneyType.PRODUCTION_DELIVER_COSTS, true)
                  prodPointInDemand.storage:setFillLevel(prodPointInDemand.storage:getFillLevel(fillTypeIdToDistribute) + amountToTransfer, fillTypeIdToDistribute)
                  distributingProdPoint.storage:setFillLevel(distributingProdPoint.storage:getFillLevel(fillTypeIdToDistribute) - amountToTransfer, fillTypeIdToDistribute)
                end
              end
            end
          end

          if remainingAmount > 0 then
            priority = priority + 1
            if priority < 11 then
              distributePriority(priority, remainingAmount, prodPointsInDemand, fillTypeIdToDistribute, distributingProdPoint)
            end
          end
        end

          --Production Revamp: Aufruf Verteilern für Priority 1
          distributePriority(1, amountToDistribute, prodPointsInDemand, fillTypeIdToDistribute, distributingProdPoint)
        end
      end
    end
  end
end

ProductionChainManager.distributeGoods = Utils.overwrittenFunction(ProductionChainManager.distributeGoods, Revamp.distributeGoods)
print("Production Revamp: ProductionChain Distribution System overwritten")



--Production Revamp: Überschrieben damit in beiden Fällen die OutputCell verwendet wird(Input hat keine Schriftzeile)
function Revamp:getCellTypeForItemInSection(superFunc, list, section, index)
  if list == self.storageList then
    return "outputCell"
  end
end

InGameMenuProductionFrame.getCellTypeForItemInSection = Utils.overwrittenFunction(InGameMenuProductionFrame.getCellTypeForItemInSection, Revamp.getCellTypeForItemInSection)



--Production Revamp: Hinzugefügt um Input-Priorität auslesen zu können
function ProductionPoint:getInputPriority(inputFillTypeId)
  return self.inputFillTypeIdsPriority[inputFillTypeId]
end



--Production Revamp: Toggle-Function um Input-Priority zu ändern
function ProductionPoint:toggleInputPriority(fillType)
  if self.inputFillTypeIds[fillType] ~= nil then
    local curPriority = self:getInputPriority(fillType)
    if curPriority == 10 then
      curPriority = 0
    else
      curPriority = curPriority + 1
    end

    self:setInputPriority(fillType, curPriority)
  end
end



--Production Revamp: Callback für die Input-Priorität zu ändern
function InGameMenuProductionFrame:priorityCallback()
  local production, productionPoint = self:getSelectedProduction()
  local fillType = self:getSelectedStorageFillType()

  if fillType ~= FillType.UNKNOWN then
    productionPoint:toggleInputPriority(fillType)
    self.storageList:reloadData()
  end
end



--Production Revamp: MenüButten für Input-Priorität & Buy-Input hinzugefügt
function Revamp:updateMenuButtons(superFunc)
  local isProductionListActive = self.productionList == FocusManager:getFocusedElement()
  local fillType, isInput = self:getSelectedStorageFillType()

  if not isProductionListActive and fillType ~= FillType.UNKNOWN and isInput then
    table.insert(self.menuButtonInfo, {
      profile = "buttonOk",
      inputAction = InputAction.MENU_ACCEPT,
      text = self.i18n:getText("Revamp_ChangePriority"),
      callback = function()
        self:priorityCallback()
      end
    })
    table.insert(self.menuButtonInfo, {
      profile = "buttonOk",
      inputAction = InputAction.MENU_CANCEL,
      text = self.i18n:getText("Revamp_BuyInputButton"),
      callback = function()
        self:buyInputMenu()
      end
    })
    self:setMenuButtonInfoDirty()
  end
end

InGameMenuProductionFrame.updateMenuButtons = Utils.appendedFunction(InGameMenuProductionFrame.updateMenuButtons, Revamp.updateMenuButtons)
print("Production Revamp: Added functions for changing and reading Input Priority")



--Production Revamp: Callback um Inputs zu kaufen
function InGameMenuProductionFrame:buyInputMenu()
  local production, productionPoint = self:getSelectedProduction()
  local fillType = self:getSelectedStorageFillType()
  local fillTypeName = g_fillTypeManager:getFillTypeByIndex(fillType).title
  local allowbuying = true
  --Production Revamp: Added option to disable buying inputs
  for x, rProductionPoint in ipairs(productionPoint.productions) do
    for index, item in ipairs(rProductionPoint.inputs) do
      if item.type == fillType then
        if item.allowbuying then
        else
          allowbuying = false
        end
      end
    end
  end
  if allowbuying then
    local missingFillLevel = self.selectedProductionPoint.storage:getFreeCapacity(fillType)
    local difficultyMultiplier = EconomyManager.getPriceMultiplier()
    local pricePerLiter = g_fillTypeManager:getFillTypeByIndex(fillType).pricePerLiter  * 2 * difficultyMultiplier

    --Production Revamp: BuyVolume definieren
    local buyVolume1 = 1000
    local buyVolume2 = 10000
    local buyVolume3 = 50000
    local buyVolume4 = math.floor(missingFillLevel, 1)

    local selectableOptions = {}
    local options = {}

    local farmMoney = g_currentMission:getMoney(self.ownerFarmId)

    if missingFillLevel > buyVolume1 then
      local price = math.floor(pricePerLiter * buyVolume1, 1)
      local fillTypeText = self.i18n:formatVolume(buyVolume1, 0).. " " ..fillTypeName
      local text = string.format(g_i18n:getText("Revamp_BuyInputText"), fillTypeText, g_i18n:formatMoney(price, 0, true))
      if price < farmMoney then
        table.insert(selectableOptions, {fillType=fillType, buyVolume=buyVolume1, price=price})
        table.insert(options, text)
      end
    end
    if missingFillLevel > buyVolume2 then
      local price = math.floor(pricePerLiter * buyVolume2, 1)
      local fillTypeText = self.i18n:formatVolume(buyVolume2, 0).. " " ..fillTypeName
      local text = string.format(g_i18n:getText("Revamp_BuyInputText"), fillTypeText, g_i18n:formatMoney(price, 0, true))
      if price < farmMoney then
        table.insert(selectableOptions, {fillType=fillType, buyVolume=buyVolume2, price=price})
        table.insert(options, text)
      end
    end
    if missingFillLevel > buyVolume3 then
      local price = math.floor(pricePerLiter * buyVolume3, 1)
      local fillTypeText = self.i18n:formatVolume(buyVolume3, 0).. " " ..fillTypeName
      local text = string.format(g_i18n:getText("Revamp_BuyInputText"), fillTypeText, g_i18n:formatMoney(price, 0, true))
      if price < farmMoney then
        table.insert(selectableOptions, {fillType=fillType, buyVolume=buyVolume3, price=price})
        table.insert(options, text)
      end
    end

    local price = math.floor(pricePerLiter * buyVolume4, 1)
    local fillTypeText = self.i18n:formatVolume(buyVolume4, 0).. " " ..fillTypeName
    local text = string.format(g_i18n:getText("Revamp_BuyInputText"), fillTypeText, g_i18n:formatMoney(price, 0, true))
    if price < farmMoney then
      table.insert(selectableOptions, {fillType=fillType, buyVolume=buyVolume4, price=price, self=self})
      table.insert(options, text)
    else
      local buyVolumeMax = math.floor(farmMoney / pricePerLiter, 1)
      local price = math.floor(pricePerLiter * buyVolumeMax, 1)
      local fillTypeText = self.i18n:formatVolume(buyVolumeMax, 0).. " " ..fillTypeName
      local text = string.format(g_i18n:getText("Revamp_BuyInputText"), fillTypeText, g_i18n:formatMoney(price, 0, true))
      table.insert(selectableOptions, {fillType=fillType, buyVolume=buyVolumeMax, price=price, self=self})
      table.insert(options, text)
    end
    if fillType ~= FillType.UNKNOWN then
      local dialogArguments = {
        text = g_i18n:getText("Revamp_BuyInput"),
        title = productionPoint.name,
        options = options,
        target = self,
        args = selectableOptions,
        callback = self.buyInput
      }
      g_gui:showOptionDialog(dialogArguments)
    end
  else
    local text = string.format(g_i18n:getText("Revamp_CantBuy"), fillTypeName)
    g_gui:showInfoDialog({
      text = text
    })
  end

  self.storageList:reloadData()
end



--Production Revamp: Inputs kaufbar machen
function InGameMenuProductionFrame:buyInput(selectedOption, args)
  local production, productionPoint = self:getSelectedProduction()
  local selectedArg = args[selectedOption]
  if selectedArg == nil then return end
  local fillType = selectedArg.fillType
  local buyVolume = selectedArg.buyVolume
  local price = selectedArg.price

  productionPoint:buyInput(fillType, buyVolume, price)
  self.storageList:reloadData()
end



--Production Revamp: BuyInput für Server
function ProductionPoint:buyInput(fillType, buyVolume, price, noEventSend)
  local currentFillLevel = self.storage:getFillLevel(fillType)
  local newFillLevel = currentFillLevel + buyVolume
  local farm = g_farmManager:getFarmById(self.ownerFarmId)

  if self.isServer then
    self.storage:setFillLevel(newFillLevel, fillType)
    g_currentMission:addMoney(-price, self.ownerFarmId, MoneyType.PRODUCTION_COSTS, true)
  end

  ProductionPointBuyInputEvent.sendEvent(self, fillType, buyVolume, price, noEventSend)
end

print("Production Revamp: Added functions for buying Inputs in Production Gui")



--Production Revamp: Neuen Finanzbereich hinzufügen
function Revamp:AddFinances()
  MoneyType.PRODUCTION_DELIVER_COSTS = MoneyType.register("productionDeliveryCosts", "productionDeliveryCosts")
  table.insert(FinanceStats.statNames, "productionDeliveryCosts")
end



--Production Revamp: Funktion um die Rezept-Farben im Multiplayer anzeigen zu können
function ProductionPoint:setProductionInputColor(productionId, inputId, color, noEventSend)
    local production = self.productionsIdToObj[productionId]
    inputId = tonumber(inputId)
    color = tonumber(color)
    production.inputs[inputId].color = color

    ProductionPointProductionInputColorEvent.sendEvent(self, productionId, inputId, color, noEventSend)
end



--Production Revamp: Hinzugefügt um Input-Prioritäten zu ändern
function ProductionPoint:setInputPriority(inputFillTypeId, priority, noEventSend)
  if self.inputFillTypeIds[inputFillTypeId] == nil then
    printf("Error: setInputPriority(): fillType '%s' is not an input fillType", g_fillTypeManager:getFillTypeNameByIndex(inputFillTypeId))

    return
  end

  priority = tonumber(priority)

  if priority > 10 then
    printf("Error: setInputPriority(): Priority '%s' is not supported", priority)
  
    return
  else
    self.inputFillTypeIdsPriority[inputFillTypeId] = priority
  end

  ProductionPointPriorityEvent.sendEvent(self, inputFillTypeId, priority, noEventSend)
end



--Production Revamp: Revamp-Übersetzungen in Globale Übersetzungen verschieben, damit diese angezeigt werden können
function Revamp:mergeModTranslations(i18n)
  local modEnvMeta = getmetatable(_G)
  local env = modEnvMeta.__index

  local global = env.g_i18n.texts
  for key, text in pairs(i18n.texts) do
    global[key] = text
  end
end

Revamp:mergeModTranslations(g_i18n)
print("Production Revamp: Added new statistic for finances")



--Production Revamp: Überschrieben um versteckte Produktionen zu ermöglichen
function Revamp:getProductionPoints(superFunc)
  local TempProductions = self.chainManager:getProductionPointsForFarmId(self.playerFarm.farmId)
  local rProduction = {}
  for index, item in ipairs(TempProductions) do
    if not item.hideFromMenu then
      table.insert(rProduction, item)
    end
  end
  table.sort(rProduction,compProductionPoints)
  return rProduction
end

--Production Revamp: Comp-Function from Achimobil InfoDisplayExpension, Sorts Productions by Name
function compProductionPoints(w1,w2)
    return w1:getName() .. w1.id < w2:getName() .. w2.id;
end
InGameMenuProductionFrame.getProductionPoints = Utils.overwrittenFunction(InGameMenuProductionFrame.getProductionPoints, Revamp.getProductionPoints)



--Production Revamp: Möglichkeit hinzugefügt, Categories und Names gleichzeitig zu verwenden 
function Revamp:loadFillTypes(superFunc, xmlFile, xmlNode)
  local fillTypeCategories = xmlFile:getValue(xmlNode .. "#fillTypeCategories")
  local fillTypeNames = xmlFile:getValue(xmlNode .. "#fillTypes")
  local fillTypes = nil
  local bypass = false
  
  if fillTypeCategories ~= nil then
    fillTypes = g_fillTypeManager:getFillTypesByCategoryNames(fillTypeCategories, "Warning: UnloadTrigger has invalid fillTypeCategory '%s'.")
    for _, fillType in pairs(fillTypes) do
      bypass = true
      self.fillTypes[fillType] = true
    end
  end
  if fillTypeNames ~= nil then
    fillTypes = g_fillTypeManager:getFillTypesByNames(fillTypeNames, "Warning: UnloadTrigger has invalid fillType '%s'.")
    for _, fillType in pairs(fillTypes) do
      bypass = true
      self.fillTypes[fillType] = true
    end
  end
  
  if bypass == false then
    self.fillTypes = nil
  end
end

UnloadTrigger.loadFillTypes = Utils.overwrittenFunction(UnloadTrigger.loadFillTypes, Revamp.loadFillTypes)



--Production Revamp: Filltypes zur Sellingstation & Unloadingstation hinzuzufügen, wenn BaseFillType bereits vorhanden ist, ausgenommen Produktionen. FillTypes werden in der Revamp. SellFillTypes von anderen Mods hinterlegt.
function Revamp:AddSellingStationFilltype()
  if #Revamp.SellFillTypes > 0 then
    for x = 1, #Revamp.SellFillTypes do
      local SellFillType = Revamp.SellFillTypes[x]
      if SellFillType.fillType~=nil then
        local fillTypeIndex = g_fillTypeManager:getFillTypeIndexByName(SellFillType.fillType)
        local baseFillTypeIndex = g_fillTypeManager:getFillTypeIndexByName(SellFillType.base)
        local fillType = g_fillTypeManager:getFillTypeByIndex(fillTypeIndex)
        local baseFillType = g_fillTypeManager:getFillTypeByIndex(baseFillTypeIndex)
        local price = fillType.pricePerLiter
        local insert = ""
        local foundone = false
        local allreadyadded = false
        if SellFillType.forceRegister == false or SellFillType.forceRegister==nil then
          for _, station in pairs(g_currentMission.storageSystem:getUnloadingStations()) do
            if station.isSellingPoint and not station.hideFromPricesMenu and not station.storeSoldGoods then
              if station.acceptedFillTypes[fillTypeIndex] == true then
                allreadyadded = true
              end
            end
          end
        end
        if allreadyadded==false then
          for _, station in pairs(g_currentMission.storageSystem:getUnloadingStations()) do
            if station.isSellingPoint and not station.hideFromPricesMenu and not station.storeSoldGoods then
              if station.acceptedFillTypes[baseFillTypeIndex] == true then
                station:addAcceptedFillType(fillTypeIndex, price, false, false)
                station:initPricingDynamics()

                foundone = true
                --Production Revamp: Bei mehreren UnloadTriggern nur in die richtigen Eintragen
                for _, unload in pairs(station.unloadTriggers) do
                  if unload.fillTypes[baseFillTypeIndex] then
                    unload.fillTypes[fillTypeIndex] = true
                  end
                end
                if insert == "" then
                  insert = station.uiName
                else
                  insert = insert ..", ".. station.uiName
                end
              end
            end
          end
          if foundone==true then
            if SellFillType.forceRegister == false then
              print("Production Revamp: Added Filltype " ..fillType.title.. " into Sellingstations " ..insert.. " for FillType " ..baseFillType.title.. ". (Mod: " ..SellFillType.modName.. ")")
            else
              print("Production Revamp: Added Filltype " ..fillType.title.. " into Sellingstations " ..insert.. " for FillType " ..baseFillType.title.. ". (forced by Mod: " ..SellFillType.modName.. ")")
            end
          else
            if SellFillType.forceRegister == false then
              print("Production Revamp: Could not add " ..fillType.title.. " into Sellingstations, no compatible Sellingstation was found (Mod: " ..SellFillType.modName.. ")")
            else
              print("Production Revamp: Could not add " ..fillType.title.. " into Sellingstations, no compatible Sellingstation was found (forced by Mod: " ..SellFillType.modName.. ")")
            end
          end
        else
          print("Production Revamp: Skipped Adding Filltype " ..fillType.title.. " into Sellingstations for FillType " ..baseFillType.title.. ". FillType allready has Sellingstations (Mod: " ..SellFillType.modName.. ")")
        end
      end
    end
  end
end

Mission00.onStartMission = Utils.appendedFunction(Mission00.onStartMission, Revamp.AddSellingStationFilltype)



--Production Revamp: Anzeige von Categorien im Kaufmenü ermöglichen
function Revamp.loadSpecValueInputFillTypes(xmlFile, customEnvironment, baseDir)
	local fillTypeNames = nil
	xmlFile:iterate("placeable.productionPoint.productions.production", function (_, productionKey)
		xmlFile:iterate(productionKey .. ".inputs.input", function (_, inputKey)
      local fillTypeCategoriesString = xmlFile:getValue(inputKey .. "#fillTypeCategory")
      if fillTypeCategoriesString == nil then
			  local fillTypeName = xmlFile:getValue(inputKey .. "#fillType")
			  fillTypeNames = fillTypeNames or {}
			  fillTypeNames[fillTypeName] = true
      else
        local fillTypes = g_fillTypeManager:getFillTypesByCategoryNames(fillTypeCategoriesString, "Warning: '" .. tostring(key) .. "' has invalid fillTypeCategory '%s'.")
        for _, fillType in pairs(fillTypes) do
          local fillTypeName = g_fillTypeManager:getFillTypeNameByIndex(fillType)
			    fillTypeNames = fillTypeNames or {}
			    fillTypeNames[fillTypeName] = true
        end
      end
		end)
	end)

	return fillTypeNames
end

ProductionPoint.loadSpecValueInputFillTypes = Utils.overwrittenFunction(ProductionPoint.loadSpecValueInputFillTypes, Revamp.loadSpecValueInputFillTypes)



--Production Revamp: Zusätzliches XML-Schema um sellFillTypes auslesen zu können 
function Revamp:AddXmlSchema()
  Revamp.XmlSchema = XMLSchema.new("revamp")
  local schema = Revamp.XmlSchema
  schema:register(XMLValueType.STRING, "modDesc.revamp.sellFillType(?)", "Revamp SellPointScript", nil, false)
  schema:register(XMLValueType.STRING, "modDesc.revamp.sellFillType(?)#fillType", "Revamp SellPointScript: Name of the newfillType", nil, false)
  schema:register(XMLValueType.STRING, "modDesc.revamp.sellFillType(?)#base", "Revamp SellPointScript: Name of the baseFillType for registering the new fillType", nil, false)
  schema:register(XMLValueType.STRING, "modDesc.revamp.sellFillType(?)#forceRegister", "Revamp SellPointScript: Force registering of the new Filltype", nil, false)
end

Revamp:AddXmlSchema()
Revamp:AddFinances()
print("Production Revamp: Loading complete")